#ifndef MACROS_H_INCLUDED_
#define MACROS_H_INCLUDED_

// Copyright and version
#define RISC_LIBRARY_NAME 	"Recoding Infrastructure for SystemC (RISC)"
#define RISC_VERSION_NUMBER 	"0.4.2"
#define RISC_COPYRIGHT		"(c) 2018 CECS, University of California, Irvine"

// Verbosity
#define RISC_VERBOSE            1
#define RISC_VERY_VERBOSE       2
#define RISC_VERY_VERY_VERBOSE  3
#define RISC_PEDANTIC           4

// Warning
#define RISC_WARNING            1
#define RISC_MORE_WARNING       2
#define RISC_MANY_WARNING       3
#define RISC_ALL_WARNING        4

// Strings
#define SYSTEMC_LW_HOME_ENV "SYSTEMC_LW_HOME"
#define SYSTEMC_OOP_HOME_ENV "SYSTEMC_OOP_HOME"
#define SYSTEMC_MIC_HOME_ENV "SYSTEMC_MIC_HOME"
#define RISC_UNPARSE_FILE_PREFIX "risc_"

#endif /* MACROS_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
