#include "systemc.h"


class InstanceDataConflictTableM: public sc_module {
public:

  SC_HAS_PROCESS(InstanceDataConflictTableM);

  InstanceDataConflictTableM(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {

    while(false) {

    }

    if(true) {

      wait(SC_ZERO_TIME);

    } else {

      wait(SC_ZERO_TIME);
    }

    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);
  }
};

class InstanceDataConflictTableA1: public sc_module {
public:

  InstanceDataConflictTableM m1;
  InstanceDataConflictTableM m2;

  InstanceDataConflictTableA1(sc_module_name mn):
    sc_module(mn),
    m1("m1"),
    m2("m2")
  { }
};

class InstanceDataConflictTableA2: public sc_module {
public:

  SC_HAS_PROCESS(InstanceDataConflictTableA2);

  InstanceDataConflictTableA2(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);
  }
};


class InstanceDataConflictTableC: public sc_module {
public:

  SC_HAS_PROCESS(InstanceDataConflictTableC);

  InstanceDataConflictTableC(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }

  void thread1()
  {
    func();
  }

  void thread2()
  {
    func();

    func();
  }

  void func()
  {
    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);
  }
};

class InstanceDataConflictTableTop: public sc_module {
public:

  InstanceDataConflictTableA1 a1;
  InstanceDataConflictTableA2 a2;
  InstanceDataConflictTableM m3;
  InstanceDataConflictTableC c;

  InstanceDataConflictTableTop(sc_module_name mn):
    sc_module(mn),
    a1("a1"),
    a2("a2"),
    m3("m3"),
    c("c")
  {

  }
};

#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  InstanceDataConflictTableTop mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
