#include "systemc.h"

class Module: sc_module {

public:
  void thread1()
  {
    for(int i = 0; i < 10; i++) {
      event.notify(SC_ZERO_TIME);
      // Do some stuff
      wait(SC_ZERO_TIME);
    }
  }

  void thread2()
  {
    for(int i = 0; i < 10; i++) {

      wait(event);
      // Do some stuff
    }
  }

  SC_HAS_PROCESS(Module);

  sc_event event;

  Module(sc_module_name mn): sc_module(mn) {

    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }
};


int sc_main(int argc, char **argv)
{
  Module m("m");
  sc_start();
  return 0;
}

